<template>
  <div class="spot-filter">
    <transition name="slideInDown">
      <template v-if="isOpen">
        <div class="spot-filter__panel">
          <div class="row">
            <div class="col-xs-3">
              <ObSelect
                :value="filters.fromLocationUuid"
                label="Откуда"
                placeholder="Выберите"
                :remote-opt="api.contract.getLocations"
                :is-auto-complete="true"
                display-exp="russian_name"
                class="mb20"
                data-qa="spot_carrier-locationFrom"
                @input="onChangeFromLocation"
              />
            </div>
            <div class="col-xs-3">
              <ObSelect
                :value="filters.toLocationUuid"
                label="Куда"
                placeholder="Выберите"
                :remote-opt="api.contract.getLocations"
                :is-auto-complete="true"
                display-exp="russian_name"
                class="mb20"
                data-qa="spot_carrier-locationTo"
                @input="onChangeToLocation"
              />
            </div>
            <div class="col-xs-2">
              <ObDatePicker
                label="Погрузка от"
                ref="from-date"
                data-qa="spot_carrier-fromDate"
                :value="filters.fromDate"
                @input="onChangeFromDate"
              />
            </div>
            <div class="col-xs-4 spot-filter__refresh">
              <div class="spot-filter__refresh-button">
                <span
                  data-qa="spot_carrier-refreshButton"
                  @click="onUpdateFilters"
                >Обновить</span>
              </div>
            </div>
          </div>
          <div class="row">
            <div class="col-xs-3">
              <ObSelect
                :value="filters.resourceSpeciesUuid"
                value-exp="uuid"
                display-exp="title"
                property="uuid"
                label="Услуга"
                placeholder="Все услуги"
                :is-standart="true"
                :remote-opt="meansTransport"
                data-qa="spot_carrier-resourceSpecies"
                @input="onChangeResourceSpecies"
              />
            </div>
            <div class="col-xs-5">
              <ObSelect
                label="Тип ТС"
                placeholder="Все типы"
                :value="filters.resourceTypeUuid"
                :items="typeOfTransports"
                :disabled="true"
                data-qa="spot_carrier-typeOfTransports"
              />
            </div>
            <div
              class="col-xs-1 clear-filter"
              data-qa="spot_carrier-clearButton"
              @click="clearFilters"
            >
              <span>Очистить</span>
              <i class="icon close" />
            </div>
          </div>
        </div>
      </template>
    </transition>
    <div
      class="spot-filter__close"
      data-qa="spot_carrier-closeButton"
      @click="showPanel"
    >
      <i :class="['icon ', isOpen ? 'chevron-up' : 'chevron-down']" />
    </div>
  </div>
</template>

<script>
import ObSelect from 'common-components/src/obComponents/obSelect'
import ObDatePicker from 'common-components/src/obComponents/obDatePickerConstructor'
import api from '@/api'

export default {
  components: {
    ObSelect,
    ObDatePicker,
  },
  data() {
    return {
      typeOfTransports: [],
      api,
      isOpen: true,
      resource: null,
      filters: {
        fromLocationUuid: null,
        toLocationUuid: null,
        resourceSpeciesUuid: null,
        fromDate: null,
        resourceTypeUuid: null,
      },
    }
  },
  computed: {
    ...mapGetters({
      spotTableItems: 'spot/spotTableItems',
      spotOrderByCarrier: 'spot/spotOrderByCarrier',
      spotAuctionByCarrier: 'spot/spotAuctionByCarrier',
      spotCarrierFilter: 'spot/carrierFilter',
    }),
  },
  methods: {
    ...mapMutations({
      setSpotCarrierFilter: 'spot/SET_SPOT_CARRIER_FILTER',
    }),
    showPanel() {
      this.isOpen = !this.isOpen
      this.$emit('changeHeight')
    },
    async meansTransport() {
      return await api.dictionaries.resources.getResourceSpeciesByClass(
        'e7519b46-faf4-11e9-8f0b-362b9e155667'
      )
    },
    async typeTransport() {
      if (this.filters.resourceSpeciesUuid) {
        this.transports = await api.dictionaries.resources.getOrderResourcesTypesBySpecies(
          this.filters.resourceSpeciesUuid
        )
      }
    },
    onChangeFromLocation(value) {
      this.filters.fromLocationUuid = value
    },
    onChangeToLocation(value) {
      this.filters.toLocationUuid = value
    },
    onChangeFromDate(value) {
      this.filters.fromDate = value
    },
    onChangeResourceSpecies(value) {
      this.filters.resourceSpeciesUuid = value
      this.getTransportTypes(value)
    },
    onUpdateFilters() {
      this.isLoaderFilter = !this.isLoaderFilter
      this.setSpotCarrierFilter(this.filters)
      this.$emit('updateFilters')
    },
    clearFilters() {
      Object.keys(this.filters).forEach((key) => (this.filters[key] = null))
      this.$refs['from-date'].localValue = ''
      this.setSpotCarrierFilter(this.filters)
      this.$emit('updateFilters')
    },
  },
}
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';

.spot-filter {
  position: relative;
  padding: 16px;
  &__refresh {
    position: absolute;
    right: 45px;
    top: 14px;
    display: flex;
    height: 52px;
    align-items: center;
    line-height: 20px;
    letter-spacing: 0.4px;
    color: $color-blue-navy-blue;
    &-button,
    &-close {
      cursor: pointer;
    }
    &-button {
      display: inherit;
      span {
        margin-left: 10px;
      }
    }
  }
  &__panel {
    margin-top: 10px;
    .row {
      margin: 5px 0;
    }
    .clear-filter {
      display: flex;
      align-items: flex-end;
      cursor: pointer;
      position: absolute;
      right: 14px;
      bottom: 15px;
      span {
        color: $color-grey-span;
        font-size: 12px;
        line-height: 20px;
      }
      .icon {
        color: $color-grey-border;
        font-size: 9px;
        line-height: 20px;
        margin-left: 8px;
      }
    }
  }
  &__close {
    position: absolute;
    top: 28px;
    right: 24px;
    cursor: pointer;
    color: $color-blue-navy-blue;
    font-size: 20px;
    z-index: 1;
  }
}

.ob-filter__refresh-button {
  opacity: 0.5 !important;
  pointer-events: none;
}
</style>
